#include <bits/stdc++.h>
using namespace std;
using ll = long long;
using ld = long double;

#define rep(i, a, b) fo(int i = a; i < (b); ++i)
#define all(x) begin(x), end(x)
#define sz(x) (int)(x).size()
typedef pair<int, int> pii;
typedef vector<int> vi;

set<pii> open;
ll solveDfs(ll w, ll h, ll x, ll y, ll len = 0) {
    open.insert({x, y});
    ll res = len % 2; // cannot move -> lose
    for(ll dx = -1; dx <= 1; dx++) {
        for(ll dy = -1; dy <= 1; dy++) {
            if(abs(dx) + abs(dy) != 1) continue;
            ll nx = x + dx, ny = y + dy;
            if(nx >= w || nx < 0) continue;
            if(ny >= h || ny < 0) continue;
            if(open.find({nx, ny}) != open.end()) continue; // already visited

            if(len % 2 == 0) // alice moves, bob needs to lose at least one of the possible moves
                res = res || !solveDfs(w, h, nx, ny, len+1);
            else // bob moves, alice needs to win all of the moves
                res = res && solveDfs(w, h, nx, ny, len+1);
        }
    }
    open.erase({x, y});
    return res;
}

void ProGamerMove() {
ll x, y, w, h;
cin >> w >> h >> x >> y;
x--; y--;

ll me = (x+y)%2;

vector<ll> par;
if(x != 0 || y != 0)
    par.push_back(0);
if(x != w-1 || y != 0)
    par.push_back((w-1)%2);
if(x != 0 || y != h-1)
    par.push_back((h-1)%2);
if(x != w-1 || y != h-1)
    par.push_back((w-1+h-1)%2);

bool win = false;
for(auto v : par) if(v != me) win = true;
if(win)
    cout << "Win" << endl;
else
    cout << "Lose" << endl;


bool bfWin = solveDfs(w, h, x, y);
cout << "BF " << bfWin << endl;
assert(bfWin == win);
}

int main() {
cin.tie(0)->sync_with_stdio(0);
cin.exceptions(cin.failbit);

// ll tt; cin >> tt;
// while(tt--) ProGamerMove();

for(ll w = 1; w < 4; w++) {
    for(ll h = 1; h < 4; h++) {
        for(ll x = 1; x <= w; x++) {
            for(ll y = 1; y <= h; y++) {
                bool b = solveDfs(w, h, x-1, y-1);
                cout << w << " " << h << " " << x << " " << y << " " << b << endl;
            }
        }
        cout << endl;
    }
}

}
